//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_color5 DeepSkyBlue
#property indicator_color6 PaleVioletRed
#property indicator_color7 DeepSkyBlue
#property indicator_color8 PaleVioletRed
#property indicator_style5 STYLE_DOT
#property indicator_style6 STYLE_DOT
#property indicator_style7 STYLE_DOT
#property indicator_style8 STYLE_DOT

//
//
//
//
//

extern int    degree           = 3;
extern double deviations       = 1.5;
extern int    bars             = 250;
extern int    futureBars       = 50;
extern int    calculatingMode  = 0;
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double regh[],regl[],chnh[],chnl[];
double reghf[],reglf[],chnhf[],chnlf[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   futureBars = MathMax(MathMin(bars,futureBars),0);
      SetIndexBuffer(0, regh);
      SetIndexBuffer(1, regl);
      SetIndexBuffer(2, chnh);
      SetIndexBuffer(3, chnl);
      SetIndexBuffer(4, reghf); SetIndexShift(4,futureBars);
      SetIndexBuffer(5, reglf); SetIndexShift(5,futureBars);
      SetIndexBuffer(6, chnhf); SetIndexShift(6,futureBars);
      SetIndexBuffer(7, chnlf); SetIndexShift(7,futureBars);
  return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double a[20,20],b[20],c[20],x[20],y[20],s[40];
double trends[][2];

int start()
{
   int i,k,n; double sum,sumh,suml;
      if (ArrayRange(trends,0)!=bars+1) ArrayResize(trends,bars+1);

   //
   //
   //
   //
   //
   
      int d = degree+1; s[1] = bars+1;

      for(k=1; k<=d*2-2; k++) { sum=0; for(n=0; n<=bars; n++) sum += MathPow(n,k); s[k+1] = sum; }
               switch(calculatingMode)
               {
                     case 1 : for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += High[n] *MathPow(n,k-1); b[k] = sum; }
                              for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += Low[n]  *MathPow(n,k-1); c[k] = sum; } break;
                     default: for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += Close[n]*MathPow(n,k-1); b[k] = sum; c[k] = sum; }
               }
      for(k=1; k<=d; k++) for(i=1; i<=d; i++) a[i,k]=s[k+i-1]; if (!iCalc(degree+1, a, b, x)) return(0);
      for(k=1; k<=d; k++) for(i=1; i<=d; i++) a[i,k]=s[k+i-1]; if (!iCalc(degree+1, a, c, y)) return(0);
      for(k=bars; k>=-futureBars; k--)
      {
            for(i=1,sumh=0,suml=0; i<=degree; i++) { sumh+=x[i+1]*MathPow(k,i); suml+=y[i+1]*MathPow(k,i); }
               if (k<=0) { reghf[k+futureBars] = x[1]+sumh; reglf[k+futureBars] = y[1]+suml; }
               if (k>=0) { regh[k]             = x[1]+sumh; regl[k]             = y[1]+suml; }
      }  
      
      //
      //
      //
      //
      //
      
      double devh = 0; 
      double devl = 0; 
         for(k=0; k<=bars; k++)
               switch(calculatingMode)
               {
                  case 1 :
                  case 2 : devh += MathPow(High[k] -regh[k],2); 
                           devl += MathPow(Low[k]  -regl[k],2); break;
                  default: devh += MathPow(Close[k]-regh[k],2); 
                           devl = devh;
               }               
         devh = MathSqrt(devh/(bars+1))*deviations;
         devl = MathSqrt(devl/(bars+1))*deviations;
             
         //
         //
         //
         //
         //
                      
         for(k=0; k<=bars; k++)
         {
            chnh[k]=regh[k]+devh;
            chnl[k]=regl[k]-devl;
            if (k<=futureBars)
            {
               chnhf[k]=reghf[k]+devh;
               chnlf[k]=reglf[k]-devl;
            }
         }
         for(k=bars,i=bars-k; k>=0; k--,i++)
         {
            trends[i][0] = trends[i-1][0];
            trends[i][1] = trends[i-1][1];
            if (High[k] >chnh[k])                     trends[i][0]= 1;
            if (Low [k] <chnl[k])                     trends[i][0]=-1;
            if (High[k] <chnh[k] && Low[k]>chnl[k])   trends[i][0]= 0;
            if (Close[k]>chnh[k])                     trends[i][1]= 1;
            if (Close[k]<chnl[k])                     trends[i][1]=-1;
            if (Close[k]<chnh[k] && Close[k]>chnl[k]) trends[i][1]= 0;
         }
         manageAlerts(bars);

   //
   //
   //
   //
   //
   
   SetIndexDrawBegin(0, Bars-bars-1);
   SetIndexDrawBegin(1, Bars-bars-1);
   SetIndexDrawBegin(2, Bars-bars-1); 
   SetIndexDrawBegin(3, Bars-bars-1); 
   SetIndexDrawBegin(4, Bars-futureBars-1); 
   SetIndexDrawBegin(5, Bars-futureBars-1); 
   SetIndexDrawBegin(6, Bars-futureBars-1); 
   SetIndexDrawBegin(7, Bars-futureBars-1); 
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//


void manageAlerts(int bars)
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1; forBar = bars-forBar;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (trends[forBar][0]!=trends[forBar-1][0])
         {
            if (trends[forBar][0]== 1) doAlert(time1,mess1," high broke the channel up");
            if (trends[forBar][0]==-1) doAlert(time1,mess1," low broke the channel down");
         }            
      
      //
      //
      //
      //
      //
      
      static datetime time2 = 0;
      static string   mess2 = "";
         if (trends[forBar][1]!=trends[forBar-1][1] && trends[forBar][1]==0)
         {
            if (trends[forBar-1][1]== 1) doAlert(time2,mess2," close retraced into channel from high");
            if (trends[forBar-1][1]==-1) doAlert(time2,mess2," close retraced into channel from low");
         }            
   }
} 
void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"  absolute strength"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

bool iCalc(int n, double& a[][],double& b[], double& x[]) 
{
   int i,j,k; double t,q;

   for(k = 1; k <=n-1; k++) 
   {
      int    l = 0; 
      double m = 0; 
         for(i=k; i<=n; i++) 
            if (MathAbs(a[i,k]) > m) { m = MathAbs(a[i,k]); l = i; } 
            if (l==0) return(false);   

            //
            //
            //
            
            if(l != k) 
            {
               for(j=1; j<=n; j++) { t = a[k,j]; a[k,j] = a[l,j]; a[l,j] = t; } 
                                     t = b[k];   b[k]   = b[l];   b[l]   = t;
            }  
            for(i=k+1; i<=n; i++) 
            {
               q = a[i,k]/a[k,k]; 
                  for(j=1; j<=n; j++) 
                    if (j == k)
                           a[i,j] = 0; 
                    else   a[i,j] = a[i,j] - q*a[k,j];
               b[i] = b[i] - q*b[k];
            }
   }
   
   //
   //
   //
   //
   //
   
      x[n] = b[n] / a[n,n]; 
      for(i=n-1; i>=1; i--) 
      {
         t = 0;  
         for(j = 1; j <= n - i; j++) 
         { 
            t    += a[i,i+j]*x[i+j]; 
            x[i] = (1.0/a[i,i])*(b[i]-t);
         }
      }
   return(true);
}

